﻿using System.Collections.Generic;
using System;
using GTANetworkAPI;
using Newtonsoft.Json;
using NeptuneEvo.GUI;
using Redage.SDK;

namespace NeptuneEvo.Core
{
    class DrivingSchool : Script
    {
        private static int minCarHe = 700; // ХП машины == 1000 ставим 700 это минимум 
        private static List<int> LicPrices = new List<int>() { 600, 1000, 3000, 6000, 10000, 10000 }; //Ценники
        private static Vector3 enterSchool = new Vector3(229.6592, 378.3658, 104.9942); //Покупка прав
        private static List<Vector3> drivingCoords = new List<Vector3>() // Координаты езда по городу
        {
            new Vector3(166.6788, 367.9709, 109.6557),     //as0
            new Vector3(75.06338, 328.0957, 112.2185),     //as1
            new Vector3(27.05613, 265.2038, 109.5388),     //as2
            new Vector3(-151.9321, 263.0995, 94.20255),     //as3
            new Vector3(-227.8934, 245.5569, 92.01941),     //as4
            new Vector3(-228.8064, 136.083, 69.70087),     //as5
            new Vector3(-145.9135, 84.96667, 70.78197),     //as6
            new Vector3(24.37703, 6.438638, 70.30566),     //as7
            new Vector3(106.2296, -24.5946, 67.84071),     //as8
            new Vector3(139.8565, 2.312728, 67.93525),     //as9
            new Vector3(202.1417, 173.1915, 105.5245),     //as10
            new Vector3(230.7764, 251.7086, 105.5266),     //as11
            new Vector3(252.4571, 325.4638, 105.5806),     //as12
            new Vector3(220.3418, 359.1553, 105.9174),     //as13
            new Vector3(219.8549, 381.869, 106.5579),     //as14
        };
        private static nLog Log = new nLog("DrivingSc");
        [ServerEvent(Event.ResourceStart)]
        public void onResourceStart()
        {
            try
            {
                var shape = NAPI.ColShape.CreateCylinderColShape(enterSchool, 1, 2, 0);
                shape.OnEntityEnterColShape += onPlayerEnterSchool;
                shape.OnEntityExitColShape += onPlayerExitSchool;

                NAPI.Marker.CreateMarker(1, enterSchool - new Vector3(0, 0, 0.7), new Vector3(), new Vector3(), 1, new Color(255, 255, 255, 220));
                NAPI.TextLabel.CreateTextLabel(Main.StringToU16("~g~Купить лицензию"), new Vector3(enterSchool.X, enterSchool.Y, enterSchool.Z + 1), 5f, 0.3f, 0, new Color(255, 255, 255));
                var blip = NAPI.Blip.CreateBlip(enterSchool, 0);
                blip.ShortRange = true;
                blip.Name = Main.StringToU16("Авто Школа");
                blip.Sprite = 545;
                blip.Color = 4;
                for (int i = 0; i < drivingCoords.Count; i++)
                {
                    var colshape = NAPI.ColShape.CreateCylinderColShape(drivingCoords[i], 4, 5, 0);
                    colshape.OnEntityEnterColShape += onPlayerEnterDrive;
                    colshape.SetData("NUMBER", i);
                }
                int ii = 0;
                foreach (var Check in Checkpoints)
                {
                    var col = NAPI.ColShape.CreateCylinderColShape(Check.Position, 1, 2, 0);
                    col.SetData("NUMBER", ii);
                    col.OnEntityEnterColShape += onPlayerEnterSchoolTest;
                    col.OnEntityExitColShape += onPlayerExitSchoolTest;
                    ii++;
                };
            }
            catch (Exception e) { Log.Write("ResourceStart: " + e.Message, nLog.Type.Error); }
        }
        #region |||| Покупка прав ||||
        #region ColShape главного меню Когда к нему подходим выводит:
        private void onPlayerEnterSchool(ColShape shape, Client player)
        {
            try
            {
                Trigger.ClientEvent(player, "JobsEinfo");
                NAPI.Data.SetEntityData(player, "INTERACTIONCHECK", 39);
            }
            catch (Exception e) { Log.Write("onPlayerEnterSchool: " + e.ToString(), nLog.Type.Error); }
        }
        private void onPlayerExitSchool(ColShape shape, Client player)
        {
            Trigger.ClientEvent(player, "JobsEinfo2");
            NAPI.Data.SetEntityData(player, "INTERACTIONCHECK", 0);
        }
        #endregion
        #region Меню где мы покупаем права:
        public static void OpenDriveSchoolMenu(Client player)
        {
            Trigger.ClientEvent(player, "JobsEinfo2");
            Trigger.ClientEvent(player, "OpenDrivingSchool",
                LicPrices[0],
                LicPrices[1],
                LicPrices[2],
                LicPrices[3],
                LicPrices[4],
                LicPrices[5]);
        }
        #endregion
        #region После покупки срабатывает это:
        [RemoteEvent("selectSchool_ID")]
        public static void startDrivingCourse(Client player, int index)
        {
            if (player.HasData("IS_DRIVING") || player.GetData("ON_WORK"))
            {
                Trigger.ClientEvent(player, "CloseDrivingSchool");
                Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вы не можете сделать это сейчас", 3000);
                return;
            }
            if (Main.Players[player].Licenses[index])
            {
                Trigger.ClientEvent(player, "CloseDrivingSchool");
                Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас уже есть эта лицензия", 3000);
                return;
            }
            switch (index)
            {
                case 0:
                    if (Main.Players[player].Money < LicPrices[0])
                    {
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[0] = true;
                    MoneySystem.Wallet.Change(player, -LicPrices[0]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[0];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[0], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно купили лицензию на мото транспорт", 3000);
                    Dashboard.sendStats(player);
                    return;
                case 1:
                    if (Main.Players[player].Money < LicPrices[1])
                    {
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    //player.SetData("IS_DRIVING", true);
                    //player.SetData("LICENSE", 1);
                    //player.SetData("CHECK", 0);
                    MoneySystem.Wallet.Change(player, -LicPrices[1]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[1];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[1], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    //Notify.Send(player, NotifyType.Info, NotifyPosition.BottomCenter, $"Ступайте во двор займите свободный транспорт", 3000);
                    Notify.Send(player, NotifyType.Info, NotifyPosition.BottomCenter, $"Подойдите к любому свободному столу в нашей авто школе и попробуйте сдать тест", 3000);
                    player.SetData("TestSchool", 1);

                    return;
                case 2:
                    if (Main.Players[player].Money < LicPrices[2])
                    {
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[2] = true;
                    MoneySystem.Wallet.Change(player, -LicPrices[2]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[2];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[2], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно купили лицензию на водный транспорт", 3000);
                    Dashboard.sendStats(player);
                    return;
                case 3:
                    if (Main.Players[player].Money < LicPrices[3])
                    {
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[3] = true;
                    MoneySystem.Wallet.Change(player, -LicPrices[3]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[3];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[3], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно купили лицензию на водный транспорт", 3000);
                    Dashboard.sendStats(player);
                    return;
                case 4:
                    if (Main.Players[player].Money < LicPrices[4])
                    {
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"", 3000);
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[4] = true;
                    MoneySystem.Wallet.Change(player, -LicPrices[4]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[4];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[4], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно купили лицензию управление вертолётами", 3000);
                    Dashboard.sendStats(player);
                    return;
                case 5:
                    if (Main.Players[player].Money < LicPrices[5])
                    {
                        Trigger.ClientEvent(player, "CloseDrivingSchool");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У Вас недостаточно денег, чтобы купить эту лицензию", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[5] = true;
                    MoneySystem.Wallet.Change(player, -LicPrices[5]);
                    Fractions.Stocks.fracStocks[6].Money += LicPrices[5];
                    GameLog.Money($"player({Main.Players[player].UUID})", $"frac(6)", LicPrices[5], $"buyLic");
                    Trigger.ClientEvent(player, "CloseDrivingSchool");
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно купили лицензию управление самолётами", 3000);
                    Dashboard.sendStats(player);
                    return;
            }
        }
        #endregion
        #endregion

        #region |||| Сдача теста ||||
        #region Координаты Столов
        private static List<Checkpoint> Checkpoints = new List<Checkpoint>()
        {
            new Checkpoint(new Vector3(227.5337, 371.517, 104.9942), 140.0437), // Сдать тест 0
            new Checkpoint(new Vector3(226.3162, 371.8558, 104.9942), 200.1652), // Собрать тест 1
            new Checkpoint(new Vector3(225.1053, 372.3355, 104.9942), 200.1652), // Собрать тест 2
            new Checkpoint(new Vector3(224.4268, 370.4944, 104.9942), 200.1652), // Собрать тест 3
            new Checkpoint(new Vector3(225.6595, 370.05, 104.9942), 200.1652), // Собрать тест 4
            new Checkpoint(new Vector3(226.8794, 369.6078, 104.9942), 200.1652), // Собрать тест 5
            new Checkpoint(new Vector3(227.9955, 369.1587, 104.9942), 200.1652), // Собрать тест 6
        };
        internal class Checkpoint
        {
            public Vector3 Position { get; }
            public double Heading { get; }

            public Checkpoint(Vector3 pos, double rot)
            {
                Position = pos;
                Heading = rot;
            }
        }
        #endregion
        #region Когда подходим к столу срабатывает чтобы сдать тест
        private void onPlayerEnterSchoolTest(ColShape shape, Client player)
        {
            try
            {
                Trigger.ClientEvent(player, "JobsEinfo");
                NAPI.Data.SetEntityData(player, "INTERACTIONCHECK", 511);
            }
            catch (Exception e) { Log.Write("onPlayerEnterSchool: " + e.ToString(), nLog.Type.Error); }
        }
        private void onPlayerExitSchoolTest(ColShape shape, Client player)
        {
            Trigger.ClientEvent(player, "JobsEinfo2");
            NAPI.Data.SetEntityData(player, "INTERACTIONCHECK", 0);
        }
        #endregion
        #region После того как прошли проверку что вы купили права идём к столу
        public static void OpenTestSchoolMenu(Client player)
        {
            try
            {
                if (player.HasData("IS_DRIVING") || player.GetData("ON_WORK"))
                {
                    Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вы не можете сделать это сейчас", 3000);
                    return;
                }
                if (!Main.Players[player].Licenses[1])
                {
                    if (player.GetData("TestSchool") == 1)
                    {
                        Trigger.ClientEvent(player, "JobsEinfo2");
                        Trigger.ClientEvent(player, "DrivingSchoolTEST");
                    }
                    else
                    {
                        Trigger.ClientEvent(player, "JobsEinfo2");
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Купите тест", 3000);
                    }
                }
                else { Trigger.ClientEvent(player, "JobsEinfo2"); Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вы уже сдавали тест", 3000); }
            }
            catch (Exception e) { Log.Write("PlayerEnterCheckpointTest: " + e.Message, nLog.Type.Error); }
        }
        #endregion
        #region После пройденного теста срабатывает проверка
        [RemoteEvent("SelectSchoolOK")]
        public static void SELECTDrivingSchoolTEST(Client player, int ok)
        {
            if (ok == 1)
            {
                player.SetData("IS_DRIVING", true);
                player.SetData("LICENSE", 1);
                player.SetData("CHECK", 0);
                Notify.Send(player, NotifyType.Info, NotifyPosition.BottomCenter, $"Ступайте во двор займите свободный транспорт", 3000);
                Trigger.ClientEvent(player, "CloseDrivingSchoolTEST");
            }
        }
        #endregion
        #endregion

        #region |||| Машина ||||
        #region Спавн машины и респавн машины
        public static List<CarInfo> CarInfos = new List<CarInfo>();
        public static void SchoolCarsSpawner()
        {
            for (int a = 0; a < CarInfos.Count; a++)
            {
                var veh = NAPI.Vehicle.CreateVehicle(CarInfos[a].Model, CarInfos[a].Position, CarInfos[a].Rotation.Z, CarInfos[a].Color1, CarInfos[a].Color2, CarInfos[a].Number);
                NAPI.Data.SetEntityData(veh, "ACCESS", "SCHOOL");
                NAPI.Data.SetEntityData(veh, "WORK", 100);
                NAPI.Data.SetEntityData(veh, "TYPE", "RENTCAR");
                NAPI.Data.SetEntityData(veh, "NUMBER", a);
                NAPI.Data.SetEntityData(veh, "ON_WORK", false);
                NAPI.Data.SetEntityData(veh, "DRIVER", null);
                veh.SetSharedData("PETROL", VehicleManager.VehicleTank[veh.Class]);
                Core.VehicleStreaming.SetEngineState(veh, false);
                Core.VehicleStreaming.SetLockStatus(veh, false);
            }
        }
        public static void respawnCar(Vehicle veh)
        {
            try
            {
                int i = NAPI.Data.GetEntityData(veh, "NUMBER");
                NAPI.Entity.SetEntityPosition(veh, CarInfos[i].Position);
                NAPI.Entity.SetEntityRotation(veh, CarInfos[i].Rotation);
                VehicleManager.RepairCar(veh);
                NAPI.Data.SetEntityData(veh, "ACCESS", "SCHOOL");
                NAPI.Data.SetEntityData(veh, "WORK", 100);
                NAPI.Data.SetEntityData(veh, "TYPE", "RENTCAR");
                NAPI.Data.SetEntityData(veh, "NUMBER", i);
                NAPI.Data.SetEntityData(veh, "ON_WORK", false);
                NAPI.Data.SetEntityData(veh, "DRIVER", null);
                Core.VehicleStreaming.SetEngineState(veh, false);
                Core.VehicleStreaming.SetLockStatus(veh, false);
                veh.SetSharedData("PETROL", VehicleManager.VehicleTank[veh.Class]);
            }
            catch (Exception e) { Log.Write("respawnCar: " + e.Message, nLog.Type.Error); }
        }
        public static void respawnCar2(Client player)
        {
            try
            {
                var a = player.GetData("NUMBERRE");
                var veh2 = NAPI.Vehicle.CreateVehicle(CarInfos[a].Model, CarInfos[a].Position, CarInfos[a].Rotation.Z, CarInfos[a].Color1, CarInfos[a].Color2, CarInfos[a].Number);
                NAPI.Data.SetEntityData(veh2, "ACCESS", "SCHOOL");
                NAPI.Data.SetEntityData(veh2, "WORK", 100);
                NAPI.Data.SetEntityData(veh2, "TYPE", "RENTCAR");
                NAPI.Data.SetEntityData(veh2, "NUMBER", a);
                NAPI.Data.SetEntityData(veh2, "ON_WORK", false);
                NAPI.Data.SetEntityData(veh2, "DRIVER", null);
                veh2.SetSharedData("PETROL", VehicleManager.VehicleTank[veh2.Class]);
                Core.VehicleStreaming.SetEngineState(veh2, false);
                Core.VehicleStreaming.SetLockStatus(veh2, false);
            }
            catch (Exception e) { Log.Write("respawnCar: " + e.Message, nLog.Type.Error); }
        }
        #endregion
        #region Когда содишься в машину сраатывает:
        [ServerEvent(Event.PlayerEnterVehicle)]
        public void onPlayerEnterVehicleHandler(Client player, Vehicle vehicle, sbyte seatid)
        {
            try
            {
                if (NAPI.Data.GetEntityData(vehicle, "TYPE") != "RENTCAR" || player.VehicleSeat != -1) return;
                if (!Main.Players[player].Licenses[1])
                {
                    if (player.HasData("IS_DRIVING") == true)
                    {
                        if (!NAPI.Data.GetEntityData(vehicle, "ON_WORK"))
                        {
                            if (NAPI.Data.GetEntityData(player, "WORK") == null) { rentCar(player); return; }
                            Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У вас уже есть машина", 3000);
                            VehicleManager.WarpPlayerOutOfVehicle(player);
                            return;
                        }
                        if (NAPI.Data.GetEntityData(player, "WORK") != vehicle)
                        {
                            Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"В машине есть водитель", 3000);
                            VehicleManager.WarpPlayerOutOfVehicle(player);
                            return;
                        }
                        NAPI.Data.SetEntityData(player, "IN_WORK_CAR", true);
                    }
                    else
                    {
                        VehicleManager.WarpPlayerOutOfVehicle(player);
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вам нужно сдать тест.", 3000);
                    }
                }
                else
                {
                    VehicleManager.WarpPlayerOutOfVehicle(player);
                    Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"У вас есть лицензия на (На этот транспорт)", 3000);
                }
            }
            catch (Exception e) { Log.Write("PlayerEnterVehicle: " + e.Message, nLog.Type.Error); }
        }
        #endregion
        #region Если всё верно то после того как вы сели в машину срабатывает:
        public static void rentCar(Client player)
        {
            if (!NAPI.Player.IsPlayerInAnyVehicle(player) || player.VehicleSeat != -1 || player.Vehicle.GetData("TYPE") != "RENTCAR") return;

            var vehicle = player.Vehicle;
            NAPI.Data.SetEntityData(player, "WORK", vehicle);
            NAPI.Data.SetEntityData(player, "ON_WORK", true);
            NAPI.Data.SetEntityData(player, "IN_WORK_CAR", true);
            NAPI.Data.SetEntityData(player, "NUMBERRE", player.Vehicle.GetData("NUMBER"));
            NAPI.Data.SetEntityData(vehicle, "ON_WORK", true);
            NAPI.Data.SetEntityData(vehicle, "DRIVER", player);

            Trigger.ClientEvent(player, "createCheckpoint", 12, 1, drivingCoords[0] - new Vector3(0, 0, 2), 4, 0, 255, 0, 0);
            Trigger.ClientEvent(player, "createWaypoint", drivingCoords[0].X, drivingCoords[0].Y);

            float bodyHealth = NAPI.Vehicle.GetVehicleBodyHealth(vehicle);
            float engineHealth = NAPI.Vehicle.GetVehicleEngineHealth(vehicle);

            Trigger.ClientEvent(player, "OpenStatsDrivingSchool", minCarHe, Convert.ToInt32(bodyHealth), Convert.ToInt32(engineHealth));
            Notify.Send(player, NotifyType.Info, NotifyPosition.BottomCenter, $"Чтобы завести транспорт, нажмите B", 3000);
            Notify.Send(player, NotifyType.Info, NotifyPosition.BottomCenter, $"Максимальная скорость у машины состовляемт 60 КМ/Ч", 3000);
            Trigger.ClientEvent(player, "SetMaxSpeedSchool");
        }
        #endregion
        #region Дамаг по машине
        [ServerEvent(Event.VehicleDamage)]
        public void OnVehicleDamage(Vehicle vehicle, float bodyHealthLoss, float engineHealthLoss)
        {

            var player = NAPI.Data.GetEntityData(vehicle, "DRIVER");
            if (NAPI.Data.GetEntityData(vehicle, "TYPE") == "RENTCAR" &&
                NAPI.Data.GetEntityData(player, "ON_WORK") &&
                NAPI.Data.GetEntityData(player, "WORK") == vehicle)
            {
                var vehHP = player.Vehicle.Health; // макс
                float bodyHealth = NAPI.Vehicle.GetVehicleBodyHealth(vehicle);
                float engineHealth = NAPI.Vehicle.GetVehicleEngineHealth(vehicle);
                if (bodyHealth < minCarHe || engineHealth < minCarHe)
                {
                    player.ResetData("IS_DRIVING");
                    NAPI.Task.Run(() =>
                    {
                        try
                        {
                            NAPI.Data.SetEntityData(player, "ON_WORK", false);
                            NAPI.Entity.DeleteEntity(player.Vehicle);
                            respawnCar2(player);
                        }
                        catch { }
                    });
                    Trigger.ClientEvent(player, "CloseStatsDrivingSchool");
                    player.ResetData("SCHOOLVEH");

                    NAPI.Data.SetEntityData(player, "WORK", null);
                    Trigger.ClientEvent(player, "deleteCheckpoint", 12, 0);
                    Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вы провалили экзамен", 3000);
                    return;
                }
                //NAPI.Util.ConsoleOutput($"{vehicle.DisplayName} - {bodyHealthLoss} - {engineHealthLoss}");
                //player.SendChatMessage(vehicle.DisplayName + ": Урон по корпусу: " + bodyHealthLoss + "| Урон по движку: " + engineHealthLoss);
                //Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"{vehicle.DisplayName} Урон по корпусу {Convert.ToInt32(bodyHealthLoss)} | Урон по движку: {Convert.ToInt32(engineHealthLoss)} всего {Convert.ToInt32(bodyHealth)} или {Convert.ToInt32(engineHealth)}", 3000);
                if (Convert.ToInt32(bodyHealthLoss) != 0)
                {
                    Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"Урон по корпусу составил: {Convert.ToInt32(bodyHealthLoss)} едениц!", 3000);
                }
                if (Convert.ToInt32(engineHealthLoss) != 0)
                {
                    Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"Урон по двигателю составил: {Convert.ToInt32(engineHealthLoss)} едениц!", 3000);
                }
                Trigger.ClientEvent(player, "OpenStatsDrivingSchool", minCarHe, Convert.ToInt32(bodyHealth), Convert.ToInt32(engineHealth));
            }
        }
        #endregion
        #region Выход из машины
        [ServerEvent(Event.PlayerExitVehicle)]
        public void onPlayerExitVehicleHandler(Client player, Vehicle vehicle)
        {
            try
            {
                if (NAPI.Data.GetEntityData(vehicle, "TYPE") == "RENTCAR" &&
                NAPI.Data.GetEntityData(player, "ON_WORK") &&
                NAPI.Data.GetEntityData(player, "WORK") == vehicle)
                {
                    Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"Если вы не сядете в машину в течение 60 секунд, то провалите экзамен", 3000);
                    NAPI.Data.SetEntityData(player, "IN_WORK_CAR", false);
                    if (player.HasData("WORK_CAR_EXIT_TIMER"))
                        Timers.Stop(NAPI.Data.GetEntityData(player, "WORK_CAR_EXIT_TIMER"));
                    NAPI.Data.SetEntityData(player, "CAR_EXIT_TIMER_COUNT", 0);
                    NAPI.Data.SetEntityData(player, "WORK_CAR_EXIT_TIMER", Timers.StartTask(1000, () => timer_playerExitWorkVehicle(player, vehicle)));
                }
            }
            catch (Exception e) { Log.Write("PlayerExitVehicle: " + e.Message, nLog.Type.Error); }
        }
        private void timer_playerExitWorkVehicle(Client player, Vehicle vehicle)
        {
            NAPI.Task.Run(() =>
            {
                try
                {
                    if (!player.HasData("WORK_CAR_EXIT_TIMER")) return;
                    if (NAPI.Data.GetEntityData(player, "IN_WORK_CAR"))
                    {
                        Timers.Stop(NAPI.Data.GetEntityData(player, "WORK_CAR_EXIT_TIMER"));
                        NAPI.Data.ResetEntityData(player, "WORK_CAR_EXIT_TIMER");
                        Log.Debug("Player exit work vehicle timer was stoped");
                        return;
                    }
                    if (NAPI.Data.GetEntityData(player, "CAR_EXIT_TIMER_COUNT") > 30)
                    {
                        respawnCar(vehicle);

                        Trigger.ClientEvent(player, "deleteCheckpoint", 12, 0);
                        player.ResetData("IS_DRIVING");
                        player.ResetData("SCHOOLVEH");
                        Trigger.ClientEvent(player, "CloseStatsDrivingSchool");
                        Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"Вы провалили экзмен", 3000);

                        NAPI.Data.SetEntityData(player, "ON_WORK", false);
                        NAPI.Data.SetEntityData(player, "WORK", null);
                        Timers.Stop(NAPI.Data.GetEntityData(player, "WORK_CAR_EXIT_TIMER"));
                        NAPI.Data.ResetEntityData(player, "WORK_CAR_EXIT_TIMER");
                        return;
                    }
                    NAPI.Data.SetEntityData(player, "CAR_EXIT_TIMER_COUNT", NAPI.Data.GetEntityData(player, "CAR_EXIT_TIMER_COUNT") + 1);

                }
                catch (Exception e)
                {
                    Log.Write("Timer_PlayerExitWorkVehicle_Collector:\n" + e.ToString(), nLog.Type.Error);
                }
            });
        }
        #endregion
        #endregion

        #region После того как мы удачно сели в машину идёт сдача города
        private void onPlayerEnterDrive(ColShape shape, Client player)
        {
            try
            {
                if (!player.IsInVehicle || player.VehicleSeat != -1) return;
                if (!player.Vehicle.HasData("ACCESS") || player.Vehicle.GetData("ACCESS") != "SCHOOL") return;
                if (!player.HasData("IS_DRIVING")) return;
                if (shape.GetData("NUMBER") != player.GetData("CHECK")) return;
                var check = player.GetData("CHECK");
                if (check == drivingCoords.Count - 1)
                {
                    player.ResetData("IS_DRIVING");
                    var vehHP = player.Vehicle.Health;
                    NAPI.Task.Run(() =>
                    {
                        try
                        {
                            NAPI.Data.SetEntityData(player, "ON_WORK", false);
                            NAPI.Entity.DeleteEntity(player.Vehicle);
                            respawnCar2(player);
                        }
                        catch { }
                    });
                    Trigger.ClientEvent(player, "CloseStatsDrivingSchool");
                    player.ResetData("SCHOOLVEH");
                    if (vehHP < minCarHe)
                    {
                        NAPI.Data.SetEntityData(player, "WORK", null);
                        Trigger.ClientEvent(player, "deleteCheckpoint", 12, 0);
                        Notify.Send(player, NotifyType.Error, NotifyPosition.BottomCenter, $"Вы провалили экзамен", 3000);
                        return;
                    }
                    Main.Players[player].Licenses[player.GetData("LICENSE")] = true;
                    Notify.Send(player, NotifyType.Success, NotifyPosition.BottomCenter, $"Вы успешно сдали экзамен", 3000);
                    NAPI.Data.SetEntityData(player, "WORK", null);
                    Dashboard.sendStats(player);
                    Trigger.ClientEvent(player, "deleteCheckpoint", 12, 0);
                    return;
                }
                player.SetData("CHECK", check + 1);
                if (check + 2 < drivingCoords.Count)
                    Trigger.ClientEvent(player, "createCheckpoint", 12, 1, drivingCoords[check + 1] - new Vector3(0, 0, 2), 4, 0, 255, 0, 0, drivingCoords[check + 2] - new Vector3(0, 0, 1.12));
                else
                    Trigger.ClientEvent(player, "createCheckpoint", 12, 1, drivingCoords[check + 1] - new Vector3(0, 0, 2), 4, 0, 255, 0, 0);
                Trigger.ClientEvent(player, "createWaypoint", drivingCoords[check + 1].X, drivingCoords[check + 1].Y);
            }
            catch (Exception e)
            {
                Log.Write("ENTERDRIVE:\n" + e.ToString(), nLog.Type.Error);
            }
        }
        #endregion

        #region |||| Игрок ||||
        #region onPlayerDisconnected Если игрок вышел из игры
        public static void onPlayerDisconnected(Client player, DisconnectionType type, string reaso)
        {
            try
            {
                if (player.GetData("ON_WORK"))
                {
                    VehicleManager.WarpPlayerOutOfVehicle(player);
                    var vehicle = player.GetData("WORK");
                    respawnCar(vehicle);
                }
            }
            catch (Exception e) { Log.Write("PlayerDisconnected: " + e.Message, nLog.Type.Error); }
        }
        #endregion
        #region Event_PlayerDeath Если игрок умер
        public static void Event_PlayerDeath(Client player, Client entityKiller, uint weapon)
        {
            try
            {
                if (!Main.Players.ContainsKey(player)) return;
                if (player.GetData("ON_WORK"))
                {
                    var vehicle = player.GetData("WORK");
                    respawnCar(vehicle);

                    Trigger.ClientEvent(player, "deleteCheckpoint", 12, 0);
                    player.ResetData("IS_DRIVING");
                    player.ResetData("SCHOOLVEH");
                    Notify.Send(player, NotifyType.Warning, NotifyPosition.BottomCenter, $"Вы провалили экзмен", 3000);
                    Trigger.ClientEvent(player, "CloseStatsDrivingSchool");

                    NAPI.Data.SetEntityData(player, "ON_WORK", false);
                    NAPI.Data.SetEntityData(player, "WORK", null);
                    Customization.ApplyCharacter(player);
                    if (player.HasData("WORK_CAR_EXIT_TIMER"))
                    {
                        //Main.StopT(NAPI.Data.GetEntityData(player, "WORK_CAR_EXIT_TIMER"), "timer_14");
                        Timers.Stop(NAPI.Data.GetEntityData(player, "WORK_CAR_EXIT_TIMER"));
                        NAPI.Data.ResetEntityData(player, "WORK_CAR_EXIT_TIMER");
                    }
                }
            }
            catch (Exception e) { Log.Write("PlayerDeath: " + e.Message, nLog.Type.Error); }
        }
        #endregion
        #endregion








    }
}